%define CACHEDIR %{_tmppath}/%{name}-temp

Name:           slviewer
Version:        1.13.3.57837
Release:        4%{?dist}
Summary:        Second Life Viewer
Group:          Applications/Multimedia
License:        GPL
URL:            http://secondlife.com/developers/opensource/
Source0:        http://secondlife.com/developers/opensource/downloads/2007/02/slviewer-src-FL-%{version}.tar.gz
# Extracted from ttf-kochi debian source tarball
# http://packages.debian.org/stable/source/ttf-kochi
# License on the ttf-kochi source (without naga10) is freely redistributable
# http://packages.debian.org/changelogs/pool/main/t/ttf-kochi/ttf-kochi_1.0.20030809-3/copyright
Source1:        unicode.ttf
Source2:        secondlife.desktop
Patch0:         slviewer-1.13.3.57520-nofmod.patch
Patch100:         slviewer-1.13.3.57520-with_fmod.patch
Patch1:         slviewer-1.13.3.57520-systemfiles.patch
Patch3:         slviewer-1.13.3.57520-optflags.patch
Patch4:         slviewer-ELFIO.patch
Patch5:         slviewer-1.13.3.57520-xmlrpc-epi.patch
Patch6:         slviewer-1.13.3.57679-manifest.patch
Patch106:         slviewer-1.13.3.57679-manifest-fmod.patch
Patch7:         slviewer-1.13.3.57679-gcc4.patch
Patch8:         slviewer-1.13.3.57837-systempaths.patch
Patch9:         slviewer-1.13.3.57837-fontpaths.patch
Patch10:        slviewer-1.13.3.57837-llimagej2coj_fixes.patch
Patch11:        slviewer-1.13.3.57837-multiarch.patch
Patch111:        slviewer-1.13.3.57837-multiarch-fmod.patch
Patch12:        slviewer-1.13.3.57837-libdb4-2.patch
Patch112:        slviewer-1.13.3.57837-libdb4-2-fmod.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  boost-devel, curl-devel, apr-devel, apr-util-devel, libvorbis-devel
BuildRequires:  gtk2-devel, scons, libjpeg-devel, SDL-devel, expat-devel
BuildRequires:  cairo-devel, pango-devel, freetype-devel, atk-devel, openssl-devel
BuildRequires:  db4-devel, libogg-devel, libstdc++-devel, e2fsprogs-devel
BuildRequires:  desktop-file-utils
# New BR
BuildRequires:  xmlrpc-epi-devel, ELFIO-devel, openjpeg-devel >= 1.1-2
## fmod3 is x86 only
%ifarch i686
BuildRequires:  fmod3-devel
%endif
Requires:       slviewer-artwork >= %{version}

# This code will probably build for other arches, but you'll need to add the 
# support into the SConstruct and add a manifest.
ExclusiveArch:  i686 x86_64 ppc

%description
Second Life is a 3-D virtual world entirely built and owned by its residents. 
slviewer is the client which enables users to enter the world of Second Life.

%prep
%setup -q -n linden
# While not having sound sucks, the FMOD bits are non-free. Patch em out.
%ifarch i686
%patch100 -p1 -b .with_fmod
%else
%patch0 -p1 -b .nofmod
%endif
# We want to use system headers and libs to make this.
%patch1 -p1 -b .syslibs
# We like our fancy optflags, so we patch in support for them.
%patch3 -p1 -b .optflags
# The proper name for libelfio is libELFIO
%patch4 -p1 -b .ELFIO
# Fedora named the xmlrpc-epi library libxmlrpc-epi to avoid conflict with xmlrpc-c
%patch5 -p1 -b .xmlrpc-epi
# Since we're using system libs, none of those libs need to be in the manifest.
%ifarch i686
%patch106 -p1 -b .manifest-fmod
%else
%patch6 -p1 -b .manifest
%endif
# Don't be stupid with the compiler.
%patch7 -p1 -b .gcc4
# Put files in normal system locations
%patch8 -p1 -b .systempaths
# Tell slviewer where to find SL fonts on Linux
%patch9 -p1 -b .fontpaths
# Fix bugs, use new openjpeg optimizations
%patch10 -p1 -b j2cojfixes
# Make sure we handle 64bit arches intelligently
%ifarch i686
%patch111 -p1 -b multiarch-fmod
%else
%patch11 -p1 -b multiarch
%endif
# Patch db-4.2 to db-4.3
%ifarch i686
%patch112 -p1 -b ldb-4.2-fmod
%else
%patch12 -p1 -b ldb-4.2
%endif

cp -a indra/newview/linux_tools/client-manifest-i686 indra/newview/linux_tools/client-manifest-x86_64
cp -a indra/newview/linux_tools/client-manifest-i686 indra/newview/linux_tools/client-manifest-ppc
sed -i 's/i686/x86_64/g' indra/newview/linux_tools/client-manifest-x86_64
sed -i 's/i686/ppc/g' indra/newview/linux_tools/client-manifest-ppc

%ifarch i686
mkdir libraries/include/fmod
ln -s %{_includedir}/fmod/* libraries/include/fmod
sed -i -e 's|"fmod_errors.h"|<fmod_errors.h>|' indra/llaudio/audioengine_fmod.cpp
sed -i -e 's|"fmod.h"|<fmod.h>|' indra/llaudio/audioengine_fmod.cpp
%endif

%build
%ifarch i386 i686
%define myarch i686
%else
%define myarch %{_build_arch}
%endif
cd indra
# If you're fixing bugs and want to save time, don't nuke the cache directory
rm -rf %{CACHEDIR}
# Make the cache dir
mkdir -p %{CACHEDIR}
export CLIENT_CPPFLAGS="`pkg-config --cflags gtk+-2.0` %{optflags} -I%{_includedir}/fmod"
TEMP_BUILD_DIR="%{CACHEDIR}" OPTFLAGS="$RPM_OPT_FLAGS" scons DISTCC=no BTARGET=client BUILD=releasefordownload ARCH=%{myarch}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cd indra/newview/SecondLife_%{myarch}_1_13_3_3

# directories
for i in app_settings character fonts help res-sdl skins; do
  cp -a $i $RPM_BUILD_ROOT%{_datadir}/%{name}/
done

# unicode.ttf
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/%{name}/fonts

# files
for i in featuretable.txt gpu_table.txt gridargs.dat launch_url.sh lsl_guide.html secondlife.ico; do
  cp -a $i $RPM_BUILD_ROOT%{_datadir}/%{name}/
done

# binaries
cp -a bin/* $RPM_BUILD_ROOT%{_bindir}/
cp -a secondlife $RPM_BUILD_ROOT%{_bindir}/

# Path cleanups
sed -i "s|bin/do|/usr/bin/do|g" $RPM_BUILD_ROOT%{_bindir}/secondlife
sed -i "s|gridargs.dat|%{_datadir}/%{name}/gridargs.dat|g" $RPM_BUILD_ROOT%{_bindir}/secondlife

# xml files don't need to be executable
chmod -x $RPM_BUILD_ROOT%{_datadir}/%{name}/skins/xui/en-us/*.xml

desktop-file-install                            \
  --vendor ""	                                \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --mode 0644                                   \
  %{SOURCE2}

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE-source.txt doc/GPL-license.txt indra/newview/SecondLife_%{myarch}_1_13_3_3/README-linux.txt
%doc indra/newview/SecondLife_%{myarch}_1_13_3_3/releasenotes.txt
%{_bindir}/*
%{_datadir}/slviewer/
%{_datadir}/applications/*.desktop

%changelog
* Mon Feb 19 2007 kwizart < kwizart at gmail.com > - 1.13.3.57837-4
- Enabled fmod-3.75 only for i386
- Patch db-4.2 to db-4.3

* Tue Feb 13 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.13.3.57837-3
- handle arches properly

* Mon Feb 12 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.13.3.57837-2
- fix some bugs, patch in support for new openjpeg opts

* Fri Feb  9 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.13.3.57837-1
- artwork license clarified, split out into noarch package

* Tue Feb  6 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.13.3.57679-1
- new build

* Thu Jan 11 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 20070108c
- Initial package for Fedora Extras
